<?xml version="1.0" encoding="utf-8" ?>
<!--

 Copyright 2016 Comcast Cable Communications Management, LLC

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 SPDX-License-Identifier: Apache-2.0
-->
<dataModelInfo>
  <version>1</version>
  <moduleName>RDKCENTRAL_AdvSecurity</moduleName>
  <author/>
  <description>Advanced Security component</description>
  <library>
    <path>libdmlasecurity</path>
    <func_Init>COSA_Init</func_Init>
  </library>
  <objects>
    <object>
      <name>DeviceInfo</name>
      <objectType>object</objectType>
      <objects>
        <object>
          <name>X_RDKCENTRAL-COM_DeviceFingerPrint</name>
              <objectType>object</objectType>
              <functions>
                <func_GetParamBoolValue>DeviceFingerPrint_GetParamBoolValue</func_GetParamBoolValue>
                <func_SetParamBoolValue>DeviceFingerPrint_SetParamBoolValue</func_SetParamBoolValue>
                <func_GetParamUlongValue>DeviceFingerPrint_GetParamUlongValue</func_GetParamUlongValue>
                <func_SetParamUlongValue>DeviceFingerPrint_SetParamUlongValue</func_SetParamUlongValue>
                <func_GetParamStringValue>DeviceFingerPrint_GetParamStringValue</func_GetParamStringValue>
                <func_SetParamStringValue>DeviceFingerPrint_SetParamStringValue</func_SetParamStringValue>
              </functions>
              <parameters>
                <parameter>
                  <name>Enable</name>
                  <type>boolean</type>
                  <syntax>bool</syntax>
                  <writable>true</writable>
                </parameter>
                <parameter>
                  <name>LoggingPeriod</name>
                  <type>unsignedInt</type>
                  <syntax>uint32</syntax>
                  <writable>true</writable>
                </parameter>
                <parameter>
                  <name>EndpointURL</name>
                  <type>string</type>
                  <syntax>string</syntax>
                  <writable>true</writable>
                </parameter>
                <parameter>
                  <name>LogLevel</name>
                  <type>unsignedInt</type>
                  <syntax>uint32</syntax>
                  <writable>true</writable>
                </parameter>
              </parameters>
        </object>
        <object>
          <name>X_RDKCENTRAL-COM_AdvancedSecurity</name>
              <objectType>object</objectType>
              <functions>
                <func_SetParamStringValue>AdvancedSecurity_SetParamStringValue</func_SetParamStringValue>
              </functions>
              <parameters>
                <parameter>
                  <name>Data</name>
                  <type>string</type>
                  <syntax>string</syntax>
                  <writable>true</writable>
                </parameter>
              </parameters>
              <objects>
                <object>
                  <name>SafeBrowsing</name>
                      <objectType>object</objectType>
                      <functions>
                        <func_GetParamBoolValue>SafeBrowsing_GetParamBoolValue</func_GetParamBoolValue>
                        <func_SetParamBoolValue>SafeBrowsing_SetParamBoolValue</func_SetParamBoolValue>
                        <func_GetParamUlongValue>SafeBrowsing_GetParamUlongValue</func_GetParamUlongValue>
                        <func_SetParamUlongValue>SafeBrowsing_SetParamUlongValue</func_SetParamUlongValue>
                        <func_GetParamStringValue>SafeBrowsing_GetParamStringValue</func_GetParamStringValue>
                        <func_Validate>SafeBrowsing_Validate</func_Validate>
                        <func_Commit>SafeBrowsing_Commit</func_Commit>
                        <func_Rollback>SafeBrowsing_Rollback</func_Rollback>
                      </functions>
                      <parameters>
                        <parameter>
                          <name>Enable</name>
                          <type>boolean</type>
                          <syntax>bool</syntax>
                          <writable>true</writable>
                        </parameter>
                        <parameter>
                          <name>LookupTimeout</name>
                          <type>unsignedInt</type>
                          <syntax>uint32</syntax>
                          <writable>true</writable>
                        </parameter>
                        <parameter>
                          <name>LookupTimeoutExceededCount</name>
                          <type>unsignedInt</type>
                          <syntax>uint32</syntax>
                          <writable>false</writable>
                        </parameter>
                        <parameter>
                          <name>Threshold</name>
                          <type>unsignedInt</type>
                          <syntax>uint32</syntax>
                          <writable>false</writable>
                        </parameter>
                        <parameter>
                          <name>Timeout</name>
                          <type>unsignedInt</type>
                          <syntax>uint32</syntax>
                          <writable>false</writable>
                        </parameter>
                        <parameter>
                          <name>Cachettl</name>
                          <type>unsignedInt</type>
                          <syntax>uint32</syntax>
                          <writable>false</writable>
                        </parameter>
                        <parameter>
                          <name>Ttl</name>
                          <type>unsignedInt</type>
                          <syntax>uint32</syntax>
                          <writable>false</writable>
                        </parameter>
                        <parameter>
                          <name>WhitelistMaxEntries</name>
                          <type>unsignedInt</type>
                          <syntax>uint32</syntax>
                          <writable>false</writable>
                        </parameter>
                        <parameter>
                          <name>Endpoint</name>
                          <type>string</type>
                          <syntax>string</syntax>
                          <writable>false</writable>
                        </parameter>
                        <parameter>
                          <name>Blockpage</name>
                          <type>string</type>
                          <syntax>string</syntax>
                          <writable>false</writable>
                        </parameter>
                        <parameter>
                          <name>Warnpage</name>
                          <type>string</type>
                          <syntax>string</syntax>
                          <writable>false</writable>
                        </parameter>
                        <parameter>
                          <name>Cacheurl</name>
                          <type>string</type>
                          <syntax>string</syntax>
                          <writable>false</writable>
                        </parameter>
                        <parameter>
                          <name>OtmDedupFqdn</name>
                          <type>string</type>
                          <syntax>string</syntax>
                          <writable>false</writable>
                        </parameter>
                      </parameters>
                </object>
                <object>
                  <name>Softflowd</name>
                      <objectType>object</objectType>
                      <functions>
                        <func_GetParamBoolValue>Softflowd_GetParamBoolValue</func_GetParamBoolValue>
                        <func_SetParamBoolValue>Softflowd_SetParamBoolValue</func_SetParamBoolValue>
                        <func_Validate>Softflowd_Validate</func_Validate>
                        <func_Commit>Softflowd_Commit</func_Commit>
                        <func_Rollback>Softflowd_Rollback</func_Rollback>
                      </functions>
                      <parameters>
                        <parameter>
                          <name>Enable</name>
                          <type>boolean</type>
                          <syntax>bool</syntax>
                          <writable>true</writable>
                        </parameter>
                      </parameters>
                </object>
              </objects>
        </object>
        <object>
          <name>X_RDKCENTRAL-COM_AdvancedParentalControl</name>
              <objectType>object</objectType>
              <functions>
                <func_GetParamBoolValue>AdvancedParentalControl_GetParamBoolValue</func_GetParamBoolValue>
                <func_SetParamBoolValue>AdvancedParentalControl_SetParamBoolValue</func_SetParamBoolValue>
              </functions>
              <parameters>
                <parameter>
                  <name>Activate</name>
                  <type>boolean</type>
                  <syntax>bool</syntax>
                  <writable>true</writable>
                </parameter>
              </parameters>
        </object>
        <object>
          <name>X_RDKCENTRAL-COM_PrivacyProtection</name>
              <objectType>object</objectType>
              <functions>
                <func_GetParamBoolValue>PrivacyProtection_GetParamBoolValue</func_GetParamBoolValue>
                <func_SetParamBoolValue>PrivacyProtection_SetParamBoolValue</func_SetParamBoolValue>
              </functions>
              <parameters>
                <parameter>
                  <name>Activate</name>
                  <type>boolean</type>
                  <syntax>bool</syntax>
                  <writable>true</writable>
                </parameter>
              </parameters>
        </object>
        <object>
        <name>X_RDKCENTRAL-COM_RFC</name>
        <objectType>object</objectType>
        <objects>
        <object>
          <name>Feature</name>
          <objectType>object</objectType>
            <objects>
            <object>
              <name>RabidFramework</name>
              <objectType>object</objectType>
              <functions>
                <func_GetParamUlongValue>RabidFramework_GetParamUlongValue</func_GetParamUlongValue>
                <func_SetParamUlongValue>RabidFramework_SetParamUlongValue</func_SetParamUlongValue>
              </functions>
              <parameters>
                <parameter>
                  <name>MemoryLimit</name>
                  <type>unsignedInt</type>
                  <syntax>uint32</syntax>
                  <writable>true</writable>
                </parameter>
                <parameter>
                  <name>MacCacheSize</name>
                  <type>unsignedInt</type>
                  <syntax>uint32</syntax>
                  <writable>true</writable>
                </parameter>
                <parameter>
                  <name>DNSCacheSize</name>
                  <type>unsignedInt</type>
                  <syntax>uint32</syntax>
                  <writable>true</writable>
                </parameter>
              </parameters>
            </object>
            <object>
              <name>AdvancedParentalControl</name>
              <objectType>object</objectType>
                <functions>
                  <func_GetParamBoolValue>AdvancedParentalControl_RFC_GetParamBoolValue</func_GetParamBoolValue>
                  <func_SetParamBoolValue>AdvancedParentalControl_RFC_SetParamBoolValue</func_SetParamBoolValue>
                </functions>
                <parameters>
                  <parameter>
                    <name>Enable</name>
                    <type>boolean</type>
                    <syntax>bool</syntax>
                    <writable>true</writable>
                  </parameter>
                </parameters>
            </object>
            <object>
              <name>PrivacyProtection</name>
              <objectType>object</objectType>
                <functions>
                  <func_GetParamBoolValue>PrivacyProtection_RFC_GetParamBoolValue</func_GetParamBoolValue>
                  <func_SetParamBoolValue>PrivacyProtection_RFC_SetParamBoolValue</func_SetParamBoolValue>
                </functions>
                <parameters>
                  <parameter>
                    <name>Enable</name>
                    <type>boolean</type>
                    <syntax>bool</syntax>
                    <writable>true</writable>
                  </parameter>
                </parameters>
              </object>
            <object>
              <name>DeviceFingerPrintICMPv6</name>
              <objectType>object</objectType>
                <functions>
                  <func_GetParamBoolValue>DeviceFingerPrintICMPv6_RFC_GetParamBoolValue</func_GetParamBoolValue>
                  <func_SetParamBoolValue>DeviceFingerPrintICMPv6_RFC_SetParamBoolValue</func_SetParamBoolValue>
                </functions>
                <parameters>
                  <parameter>
                    <name>Enable</name>
                    <type>boolean</type>
                    <syntax>bool</syntax>
                    <writable>true</writable>
                  </parameter>
                </parameters>
            </object>
            <object>
              <name>WS-Discovery_Analysis</name>
              <objectType>object</objectType>
                <functions>
                  <func_GetParamBoolValue>WS_Discovery_Analysis_RFC_GetParamBoolValue</func_GetParamBoolValue>
                  <func_SetParamBoolValue>WS_Discovery_Analysis_RFC_SetParamBoolValue</func_SetParamBoolValue>
                </functions>
                <parameters>
                  <parameter>
                    <name>Enable</name>
                    <type>boolean</type>
                    <syntax>bool</syntax>
                    <writable>true</writable>
                  </parameter>
                </parameters>
            </object>
            <object>
              <name>AdvancedSecurityOTM</name>
              <objectType>object</objectType>
                <functions>
                  <func_GetParamBoolValue>AdvancedSecurityOTM_RFC_GetParamBoolValue</func_GetParamBoolValue>
                  <func_SetParamBoolValue>AdvancedSecurityOTM_RFC_SetParamBoolValue</func_SetParamBoolValue>
                </functions>
                <parameters>
                  <parameter>
                    <name>Enable</name>
                    <type>boolean</type>
                    <syntax>bool</syntax>
                    <writable>true</writable>
                  </parameter>
                </parameters>
            </object>
            <object>
              <name>AdvanceSecurityUserSpace</name>
              <objectType>object</objectType>
                <functions>
                  <func_GetParamBoolValue>AdvanceSecurityUserSpace_RFC_GetParamBoolValue</func_GetParamBoolValue>
                  <func_SetParamBoolValue>AdvanceSecurityUserSpace_RFC_SetParamBoolValue</func_SetParamBoolValue>
                </functions>
                <parameters>
                  <parameter>
                    <name>Enable</name>
                    <type>boolean</type>
                    <syntax>bool</syntax>
                    <writable>true</writable>
                  </parameter>
                </parameters>
            </object>
            <object>
              <name>AdvanceSecurityCujoTracer</name>
              <objectType>object</objectType>
                <functions>
                  <func_GetParamBoolValue>AdvanceSecurityCujoTracer_RFC_GetParamBoolValue</func_GetParamBoolValue>
                  <func_SetParamBoolValue>AdvanceSecurityCujoTracer_RFC_SetParamBoolValue</func_SetParamBoolValue>
                </functions>
                <parameters>
                  <parameter>
                    <name>Enable</name>
                    <type>boolean</type>
                    <syntax>bool</syntax>
                    <writable>true</writable>
                  </parameter>
                </parameters>
            </object>
            <object>
              <name>AdvanceSecurityCujoTelemetry</name>
              <objectType>object</objectType>
                <functions>
                  <func_GetParamBoolValue>AdvanceSecurityCujoTelemetry_RFC_GetParamBoolValue</func_GetParamBoolValue>
                  <func_SetParamBoolValue>AdvanceSecurityCujoTelemetry_RFC_SetParamBoolValue</func_SetParamBoolValue>
                </functions>
                <parameters>
                  <parameter>
                    <name>Enable</name>
                    <type>boolean</type>
                    <syntax>bool</syntax>
                    <writable>true</writable>
                  </parameter>
                </parameters>
            </object>
            <object>
              <name>AdvSecAgentRaptr</name>
              <objectType>object</objectType>
                <functions>
                  <func_GetParamBoolValue>AdvSecAgentRaptr_RFC_GetParamBoolValue</func_GetParamBoolValue>
                  <func_SetParamBoolValue>AdvSecAgentRaptr_RFC_SetParamBoolValue</func_SetParamBoolValue>
                </functions>
                <parameters>
                  <parameter>
                    <name>Enable</name>
                    <type>boolean</type>
                    <syntax>bool</syntax>
                    <writable>true</writable>
                  </parameter>
                </parameters>
            </object>
            </objects>
        </object>
      </objects>
      </object>
      </objects>
    </object>
  </objects>
</dataModelInfo>
